USE [COWS]
GO
_CreateObject 'SP','dbo','getVendorOrderEmailData'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- ================================================================
-- Author:		Lakshmi Kadiyala
-- Create date: 12th July 2011
-- Description:	Returns data needed for Vendor Order Email
-- kh946640 03/22/18 COWS DB Restructuring as columns have been moved from fsa_ordr->fsa_ordr_cpe_line_item table for DualPort project(PJ020783 - CR93)
-- ================================================================

ALTER PROCEDURE [dbo].[getVendorOrderEmailData]
	@VendorOrderID INT
AS
BEGIN
SET NOCOUNT ON;

BEGIN TRY
	DECLARE @CategoryID TINYINT
	DECLARE @OrderID INT
	DECLARE @FTN varchar(20)
	DECLARE @OrderTypeID TINYINT
	
	SELECT @CategoryID = ISNULL(ORDR_CAT_ID, 0),
			@OrderID = VO.ORDR_ID
	FROM dbo.VNDR_ORDR VO 	WITH (NOLOCK)
	INNER JOIN dbo.ORDR OD 	WITH (NOLOCK) ON VO.ORDR_ID = OD.ORDR_ID
	WHERE VO.VNDR_ORDR_ID = @VendorOrderID

	IF(@CategoryID IN (2,6)) -- FSA
	BEGIN
		OPEN SYMMETRIC KEY FS@K3y 
		DECRYPTION BY CERTIFICATE S3cFS@CustInf0;

		SELECT @FTN = FTN,
				@OrderTypeID = LOT.ORDR_TYPE_ID
		FROM dbo.FSA_ORDR FO	WITH (NOLOCK)
		INNER JOIN dbo.LK_ORDR_TYPE LOT WITH (NOLOCK) ON FO.ORDR_TYPE_CD = LOT.FSA_ORDR_TYPE_CD 
		WHERE FO.ORDR_ID = @OrderID

		--Get Vendor Emails
		SELECT TOP 1
			FO.FTN, 
			CASE WHEN (O.CSG_LVL_ID=0) THEN FOC.CUST_NME ELSE ISNULL(dbo.decryptBinaryData(csd.CUST_NME),'') END as CUST_NME, 
			CASE WHEN (O.CSG_LVL_ID=0) THEN OA.CTY_NME ELSE ISNULL(dbo.decryptBinaryData(csd2.CTY_NME),'') END as CTY_NME, 
			LC.CTRY_NME,
			0	AS ISIPL,
			LOT.ORDR_TYPE_ID,
			CASE ISNULL(FO.ORDR_SUB_TYPE_CD,'')				
				WHEN 'HCDN' THEN 'Downgrade'
				WHEN 'COLODN' THEN 'Downgrade'
				WHEN 'HCUP' THEN 'Upgrade'
				WHEN 'COLOUP' THEN 'Upgrade'
				ELSE LOT.ORDR_TYPE_DES
			END AS ORDR_TYPE_DES,
			--CASE 
			--	WHEN	o.PLTFRM_CD	IN ('RS','CP') THEN	web.getVendorName(O.ORDR_ID)
			--END	AS OFFNET_VNDR_NME,
			CASE o.PLTFRM_CD
								WHEN 'CP'	THEN ISNULL(cp.VNDR_NME,ISNULL(rcp.VNDR_NME,ISNULL(web.getVendorName(o.ORDR_ID, o.ORDR_CAT_ID, o.PLTFRM_CD, LOT.FSA_ORDR_TYPE_CD),lvo.VNDR_NME)))
								WHEN 'RS'	THEN ISNULL(rs.VNDR_NME,ISNULL(rrs.VNDR_NME,ISNULL(web.getVendorName(o.ORDR_ID, o.ORDR_CAT_ID, o.PLTFRM_CD, LOT.FSA_ORDR_TYPE_CD),lvo.VNDR_NME)))
								ELSE ''
								END AS	OFFNET_VNDR_NME
			,FO.TSUP_RFQ_NBR,
			--CASE 
			--	WHEN	o.PLTFRM_CD	= 'SF' THEN	web.getVendorName(O.ORDR_ID)
			--END	AS ONNET_VNDR_NME,
			CASE o.PLTFRM_CD
								WHEN 'SF'	THEN ISNULL(sf.VNDR_NME,ISNULL(rsf.VNDR_NME,ISNULL(web.getVendorName(o.ORDR_ID, o.ORDR_CAT_ID, o.PLTFRM_CD, LOT.FSA_ORDR_TYPE_CD),lvo.VNDR_NME)))
								ELSE ''
								END AS	ONNET_VNDR_NME
			,ISNULL(LPT.PROD_TYPE_ID, 0) PROD_TYPE_ID,
			VO.VNDR_ORDR_ID,
			VO.TRMTG_CD
		FROM	dbo.FSA_ORDR FO 	WITH (NOLOCK)
	INNER JOIN	dbo.ORDR O  	WITH (NOLOCK) ON FO.ORDR_ID = O.ORDR_ID 
	INNER JOIN	dbo.VNDR_ORDR VO	WITH (NOLOCK) ON FO.ORDR_ID = VO.ORDR_ID
	INNER JOIN	dbo.LK_PPRT P WITH (NOLOCK) ON O.PPRT_ID = P.PPRT_ID
	INNER JOIN	dbo.LK_PROD_TYPE LPT WITH (NOLOCK) ON FO.PROD_TYPE_CD = LPT.FSA_PROD_TYPE_CD
	INNER JOIN	dbo.LK_ORDR_TYPE LOT WITH (NOLOCK)ON P.ORDR_TYPE_ID = LOT.ORDR_TYPE_ID 
	LEFT OUTER JOIN dbo.FSA_ORDR_CUST FOC WITH (NOLOCK) ON FO.ORDR_ID = FOC.ORDR_ID			
	LEFT OUTER JOIN dbo.ORDR_ADR OA WITH (NOLOCK) ON FO.ORDR_ID = OA.ORDR_ID	AND OA.ADR_TYPE_ID IN (6,18)
	LEFT OUTER JOIN dbo.LK_CTRY LC WITH (NOLOCK) ON OA.CTRY_CD = LC.CTRY_CD
	LEFT JOIN	dbo.FSA_ORDR_CPE_LINE_ITEM CPED WITH (NOLOCK) ON CPED.ORDR_ID= FO.ORDR_ID
	LEFT JOIN	dbo.LK_VNDR		sf	WITH (NOLOCK)			ON	sf.VNDR_CD		=	CPED.CXR_ACCS_CD
	LEFT JOIN	dbo.LK_VNDR		cp	WITH (NOLOCK)			ON	cp.VNDR_CD		=	FO.VNDR_VPN_CD	
	LEFT JOIN	dbo.LK_VNDR		rs	WITH (NOLOCK)			ON	rs.VNDR_CD		=	FO.INSTL_VNDR_CD																
	LEFT JOIN	dbo.FSA_ORDR	rfs	WITH (NOLOCK)			ON	rfs.FTN		=	FO.RELTD_FTN 
	LEFT JOIN	dbo.FSA_ORDR_CPE_LINE_ITEM rCPED WITH (NOLOCK) ON rCPED.ORDR_ID= rfs.ORDR_ID
	LEFT JOIN	dbo.LK_VNDR		rsf	WITH (NOLOCK)			ON	rsf.VNDR_CD		=	rCPED.CXR_ACCS_CD
	LEFT JOIN	dbo.LK_VNDR		rcp	WITH (NOLOCK)			ON	rcp.VNDR_CD		=	rfs.VNDR_VPN_CD	
	LEFT JOIN	dbo.LK_VNDR		rrs	WITH (NOLOCK)			ON	rrs.VNDR_CD		=	rfs.INSTL_VNDR_CD
	LEFT JOIN	dbo.VNDR_FOLDR	vf	WITH (NOLOCK)			ON	vo.VNDR_FOLDR_ID = vf.VNDR_FOLDR_ID
	LEFT JOIN	dbo.LK_VNDR		lvo WITH (NOLOCK)			ON	lvo.VNDR_CD = vf.VNDR_CD
	LEFT JOIN	dbo.CUST_SCRD_DATA csd WITH (NOLOCK)		ON	csd.SCRD_OBJ_ID=foc.FSA_ORDR_CUST_ID AND csd.SCRD_OBJ_TYPE_ID=5
	LEFT JOIN	dbo.CUST_SCRD_DATA csd2 WITH (NOLOCK)		ON	csd2.SCRD_OBJ_ID=OA.ORDR_ADR_ID AND csd2.SCRD_OBJ_TYPE_ID=14
		WHERE	FO.ORDR_ID = @OrderID 
		AND		FOC.CIS_LVL_TYPE IN ('H5','H6')
		AND		VO.VNDR_ORDR_ID	=	@VendorOrderID
		ORDER BY OA.ADR_TYPE_ID DESC

		--Get Circuits
		SELECT DISTINCT
			@VendorOrderID VNDR_ORDR_ID,
			0 AS TRMTG_CD,
			C.CKT_ID,
			C.VNDR_CKT_ID,
			C.VNDR_ORDR_ID,			
			CC1.MAX_VER_ID,
			CC2.QOT_NBR,
			CC4.TRGT_DLVRY_DT,
			CC4.VNDR_CNFRM_DSCNCT_DT,
			0 AS TRMTG_CD
		FROM dbo.CKT C	WITH (NOLOCK)
		LEFT OUTER JOIN
		(
			SELECT CKT_ID,
				   MAX(VER_ID) MAX_VER_ID
			FROM dbo.CKT_COST	WITH (NOLOCK)
			GROUP BY CKT_ID			
		) CC1 ON C.CKT_ID = CC1.CKT_ID
		LEFT OUTER JOIN dbo.CKT_COST CC2 	WITH (NOLOCK) ON CC1.CKT_ID = CC2.CKT_ID	AND CC1.MAX_VER_ID = CC2.VER_ID
		LEFT OUTER JOIN
		(
			SELECT CKT_ID,
				   MAX(VER_ID) MAX_VER_ID
			FROM dbo.CKT_MS	WITH (NOLOCK)
			GROUP BY CKT_ID			
		) CC3 ON C.CKT_ID = CC3.CKT_ID
		LEFT OUTER JOIN dbo.CKT_MS CC4 	WITH (NOLOCK) ON CC3.CKT_ID = CC4.CKT_ID	AND CC3.MAX_VER_ID = CC4.VER_ID
		WHERE C.VNDR_ORDR_ID = @VendorOrderID OR C.ORDR_ID = @OrderID

		--Get PL Number
		IF(@OrderTypeID = 7)
		BEGIN
			SELECT
				DISC_PL_NBR AS PLN_NME,
				'' PLN_SEQ_NBR
			FROM dbo.FSA_ORDR_CPE_LINE_ITEM WITH (NOLOCK)
			WHERE ORDR_ID = @OrderID
		END
		ELSE
		BEGIN
			SELECT 
				PLN_NME,
				PLN_SEQ_NBR
			FROM dbo.NRM_CKT WITH (NOLOCK)
			WHERE FTN = @FTN
			ORDER BY PLN_SEQ_NBR
		END
	END
	ELSE IF(@CategoryID IN (1,5)) --IPL
	BEGIN
		OPEN SYMMETRIC KEY FS@K3y 
		DECRYPTION BY CERTIFICATE S3cFS@CustInf0;
		--Get Vendor Emails
		SELECT	TOP 1	ipl.ORDR_ID												AS	FTN,
						CASE VO.TRMTG_CD	
							WHEN 0	THEN ipl.ORGTNG_CO_ID										
							WHEN 1	THEN ipl.TRMTG_CO_CD
							END
						AS	CUST_NME, 
						CASE WHEN (O.CSG_LVL_ID=0) THEN OA.CTY_NME ELSE ISNULL(dbo.decryptBinaryData(csd.CTY_NME),'') END as CTY_NME, 
						lc.CTRY_NME,
						1														AS	ISIPL,
						LOT.ORDR_TYPE_ID,
						LOT.ORDR_TYPE_DES,
						ISNULL(fc.CXR_NME,'') OFFNET_VNDR_NME,
						'' TSUP_RFQ_NBR,
						ISNULL(fc.CXR_NME,'') ONNET_VNDR_NME,
						ISNULL(ipl.PROD_TYPE_ID, 0) PROD_TYPE_ID,
						VO.VNDR_ORDR_ID,
						VO.TRMTG_CD
		FROM			dbo.IPL_ORDR		ipl	WITH (NOLOCK)
			INNER JOIN	dbo.ORDR			O  	WITH (NOLOCK)	ON	ipl.ORDR_ID	=	O.ORDR_ID
			INNER JOIN	dbo.LK_PPRT			P	WITH (NOLOCK)	ON	O.PPRT_ID	=	P.PPRT_ID
			INNER JOIN	dbo.LK_ORDR_TYPE	LOT WITH (NOLOCK)	ON	P.ORDR_TYPE_ID = LOT.ORDR_TYPE_ID 
			INNER JOIN	dbo.VNDR_ORDR		VO	WITH (NOLOCK)	ON	ipl.ORDR_ID	=	VO.ORDR_ID
			LEFT JOIN	dbo.ORDR_ADR		oa	WITH (NOLOCK)	ON	ipl.ORDR_ID	=	oa.ORDR_ID
			LEFT JOIN	dbo.LK_CTRY			lc	WITH (NOLOCK)	ON	oa.CTRY_CD	=	lc.CTRY_CD
			LEFT JOIN	dbo.IPL_ORDR_ACCS_INFO ai WITH (NOLOCK)	ON	ipl.ORDR_ID =	ai.ORDR_ID 
																AND VO.TRMTG_CD = CASE ai.ACCS_TYPE_ID
																						WHEN 'Originating' THEN 0
																						WHEN 'Terminating' THEN 1
																					END
			LEFT JOIN	dbo.LK_FRGN_CXR fc WITH (NOLOCK) ON ai.CXR_CD = fc.CXR_CD
			LEFT JOIN	dbo.CUST_SCRD_DATA csd WITH (NOLOCK)		ON	csd.SCRD_OBJ_ID=OA.ORDR_ADR_ID AND csd.SCRD_OBJ_TYPE_ID=14
			WHERE	ipl.ORDR_ID		=	@OrderID			
				AND	oa.ADR_TYPE_ID	=	CASE	VO.TRMTG_CD 
											WHEN 0 THEN 11 
											WHEN 1 THEN 12 
										END
				AND	VO.VNDR_ORDR_ID	=	@VendorOrderID

		--Get Circuits
		SELECT DISTINCT	
						VO.VNDR_ORDR_ID,
						VO.TRMTG_CD,
						c.CKT_ID,
						c.VNDR_CKT_ID,
						c.VNDR_ORDR_ID,						
						cc1.MAX_VER_ID,
						cc2.QOT_NBR,
						cc4.TRGT_DLVRY_DT,
						cc4.VNDR_CNFRM_DSCNCT_DT
		FROM			dbo.VNDR_ORDR VO WITH (NOLOCK)  
		INNER JOIN		dbo.CKT		c	WITH (NOLOCK) ON VO.VNDR_ORDR_ID = C.VNDR_ORDR_ID
		LEFT OUTER JOIN (	SELECT	CKT_ID, 
									MAX(VER_ID) AS MAX_VER_ID
							FROM	dbo.CKT_COST WITH (NOLOCK)
							GROUP BY CKT_ID	) cc1		ON	c.CKT_ID		= cc1.CKT_ID
		LEFT OUTER JOIN dbo.CKT_COST cc2  WITH (NOLOCK)	ON	cc1.CKT_ID		= cc2.CKT_ID	
														AND cc1.MAX_VER_ID	= cc2.VER_ID
		LEFT OUTER JOIN
		(
			SELECT CKT_ID,
				   MAX(VER_ID) MAX_VER_ID
			FROM dbo.CKT_MS	WITH (NOLOCK)
			GROUP BY CKT_ID			
		) CC3 ON C.CKT_ID = CC3.CKT_ID
		LEFT OUTER JOIN dbo.CKT_MS CC4 	WITH (NOLOCK) ON CC3.CKT_ID = CC4.CKT_ID	AND CC3.MAX_VER_ID = CC4.VER_ID
		WHERE VO.ORDR_ID = @OrderID
		
		--Get PL Number
		SELECT	
			PRE_XST_PL_NBR	AS	PLN_NME,
			LTRIM(REPLACE(ck.PL_SEQ_NBR, PRE_XST_PL_NBR, '')) AS PLN_SEQ_NBR
		FROM	dbo.IPL_ORDR	ipl	WITH (NOLOCK)
		LEFT OUTER JOIN dbo.CKT ck	WITH (NOLOCK) ON ipl.ORDR_ID = ck.ORDR_ID
		WHERE	ipl.ORDR_ID		=	@orderID
	END	
	ELSE IF(@CategoryID = 4) --NCCO
	BEGIN
		OPEN SYMMETRIC KEY FS@K3y 
		DECRYPTION BY CERTIFICATE S3cFS@CustInf0;
		--Get Vendor Emails
		SELECT	TOP 1	ncco.ORDR_ID												AS	FTN,
						CASE WHEN (O.CSG_LVL_ID=0) THEN ncco.CUST_NME ELSE ISNULL(dbo.decryptBinaryData(csd.CUST_NME),'') END as CUST_NME, 
						ISNULL(ncco.SITE_CITY_NME,'')	AS	CTY_NME,
						lc.CTRY_NME AS CTRY_NME,
						0														AS	ISIPL,
						LOT.ORDR_TYPE_ID,
						LOT.ORDR_TYPE_DES,
						ISNULL(lv.VNDR_NME,'') OFFNET_VNDR_NME,
						'' TSUP_RFQ_NBR,
						ISNULL(lv.VNDR_NME,'') ONNET_VNDR_NME,
						ISNULL(ncco.PROD_TYPE_ID, 0) PROD_TYPE_ID,
						VO.VNDR_ORDR_ID,
						VO.TRMTG_CD
		FROM			dbo.NCCO_ORDR		ncco	WITH (NOLOCK)
			INNER JOIN	dbo.ORDR			O  	WITH (NOLOCK)	ON	ncco.ORDR_ID	=	O.ORDR_ID
			INNER JOIN	dbo.LK_PPRT			P	WITH (NOLOCK)	ON	O.PPRT_ID		=	P.PPRT_ID
			INNER JOIN	dbo.LK_ORDR_TYPE	LOT WITH (NOLOCK)	ON	P.ORDR_TYPE_ID =	LOT.ORDR_TYPE_ID 
			INNER JOIN	dbo.VNDR_ORDR		VO	WITH (NOLOCK)	ON	ncco.ORDR_ID	=	VO.ORDR_ID
			LEFT JOIN	dbo.LK_CTRY			lc	WITH (NOLOCK)	ON	ncco.CTRY_CD	=	lc.CTRY_CD
			LEFT JOIN	dbo.LK_VNDR			lv WITH (NOLOCK)	ON	lv.VNDR_CD		=	ncco.VNDR_CD
			LEFT JOIN	dbo.CUST_SCRD_DATA csd WITH (NOLOCK)		ON	csd.SCRD_OBJ_ID=ncco.ORDR_ID AND csd.SCRD_OBJ_TYPE_ID=10
			WHERE	ncco.ORDR_ID		=	@OrderID			
				AND	VO.VNDR_ORDR_ID	=	@VendorOrderID

		--Get Circuits
		SELECT DISTINCT	
						VO.VNDR_ORDR_ID,
						VO.TRMTG_CD,
						c.CKT_ID,
						c.VNDR_CKT_ID,
						c.VNDR_ORDR_ID,						
						cc1.MAX_VER_ID,
						cc2.QOT_NBR,
						cc4.TRGT_DLVRY_DT,
						cc4.VNDR_CNFRM_DSCNCT_DT
		FROM			dbo.VNDR_ORDR VO WITH (NOLOCK)  
		INNER JOIN		dbo.CKT		c	WITH (NOLOCK) ON VO.VNDR_ORDR_ID = C.VNDR_ORDR_ID
		LEFT OUTER JOIN (	SELECT	CKT_ID, 
									MAX(VER_ID) AS MAX_VER_ID
							FROM	dbo.CKT_COST WITH (NOLOCK)
							GROUP BY CKT_ID	) cc1		ON	c.CKT_ID		= cc1.CKT_ID
		LEFT OUTER JOIN dbo.CKT_COST cc2  WITH (NOLOCK)	ON	cc1.CKT_ID		= cc2.CKT_ID	
														AND cc1.MAX_VER_ID	= cc2.VER_ID
		LEFT OUTER JOIN
		(
			SELECT CKT_ID,
				   MAX(VER_ID) MAX_VER_ID
			FROM dbo.CKT_MS	WITH (NOLOCK)
			GROUP BY CKT_ID			
		) CC3 ON C.CKT_ID = CC3.CKT_ID
		LEFT OUTER JOIN dbo.CKT_MS CC4 	WITH (NOLOCK) ON CC3.CKT_ID = CC4.CKT_ID	AND CC3.MAX_VER_ID = CC4.VER_ID
		WHERE VO.ORDR_ID = @OrderID
		
		--Get PL Number
		SELECT	
			CASE WHEN  ISNULL(ncco.PL_NBR,'') IN ('','n/a')
					THEN ISNULL(SUBSTRING(ISNULL(ck.PL_SEQ_NBR,''),0,CHARINDEX(' ',ck.PL_SEQ_NBR,0)),'')
				 ELSE ISNULL(ncco.PL_NBR,SUBSTRING(ISNULL(ck.PL_SEQ_NBR,''),0,CHARINDEX(' ',ck.PL_SEQ_NBR,0)))
				END AS PLN_NME,
			ISNULL(SUBSTRING(ISNULL(ck.PL_SEQ_NBR,''),CHARINDEX(' ',ck.PL_SEQ_NBR,0) + 1,LEN(ISNULL(ck.PL_SEQ_NBR,''))),'') AS PLN_SEQ_NBR
		FROM	dbo.NCCO_ORDR	ncco	WITH (NOLOCK)
		LEFT OUTER JOIN dbo.CKT ck	WITH (NOLOCK) ON ncco.ORDR_ID = ck.ORDR_ID
		WHERE	ncco.ORDR_ID		=	@orderID
			
			
	END	
END TRY
BEGIN CATCH
	EXEC [dbo].[insertErrorInfo]
END CATCH
END
GO
